// C Source File
// Created 5/11/2004; 6:36:41 PM

#include "all.h"

static inline char CH_draw_menu(void);
static inline void CH_move_player(int);
void CH_check_angle(int);
static inline void CH_draw_player(int);
static inline void CH_play(void);
static inline void CH_draw_scene(void);
static inline void CH_check_if_collision(int);
static inline void CH_check_if_trash_is_near(int);
static inline void CH_create_moving_trash(int,int);
static inline void CH_animate_da_trash(void);
void CH_update_score(void); //do not "static inline"
static inline void CH_XOR_a_trash(long,long);
static inline void CH_XOR_an_animated_trash(int,int);
static inline void CH_change_to_old_coord(int);
static inline void CH_create_one_trash(void); 	//do not "static inline"
static inline void CH_create_pack_of_trash(void);
static inline void CH_draw_winner(void);
void CH_main(void);

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun


//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

char CH_NOP,CH_quit;
char *CH_buffer[5];
unsigned char (*CH_moving_trash)[2];
int CH_time,CH_winner;
int *CH_Xcos,*CH_Bcos;		//shifted 7 bit

CH_PLAYER_STRUCT CH_p[4];
CH_PIECE_OF_TRASH_STRUCT (*CH_array_of_trash)[CH_trash_array_height];



//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline char CH_draw_menu() {

	draw_pic(CH_layer1,CH_layer2,GrayGetPlane(1)+(30*11+2),GrayGetPlane(0)+(30*11+2),16,38,no_score);
 	FontSetSys(F_4x6);
	GrayDrawStr(40,65,"[1] Start",A_NORMAL);
	GrayDrawStr(40,75,"[2] Exit",A_NORMAL);
	GrayDrawStr(40,85,"[3] Number of player: 2",A_NORMAL);
	CH_NOP = 2;

  while (1) {
  	if (_keytest(RR_1)) {
   		return 1;
    }
    if (_keytest(RR_2)) {
   		return 0;
    }
    if (_keytest(RR_3)) {
    	CH_NOP++;
    	if (CH_NOP == 5)
    	CH_NOP = 2;
    	GrayDrawChar(117,85,CH_NOP+48,A_REPLACE);
    	while (_keytest(RR_3)) {};
    }
	}
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline void CH_draw_winner() {
	PortSet(CH_buffer[2],239,99);
	ClrScr();
	Sprite16_OR(0,0,15,CH_dude,CH_buffer[2]);	
	DrawChar(0+5, 0+5,CH_winner+49, A_XOR);	
	unsigned short it[15];
	Sprite16Get(0,0,15,CH_buffer[2],it);
	FontSetSys(F_6x8);
	DrawStr(56,90,"You Win",A_NORMAL);
	int i=10,dir=1;
	PortSet(CH_buffer[2],239,84);//with "84", the next ClrScr() won't erase the message. How clever!
	while (!_keytest(RR_ENTER)) {
		i+=dir;
		if (i==5*16-5 || i == 8) {
			dir = -dir;
		}
		ClrScr();
		ScaleSprite16_OR(it,CH_buffer[2],(LCD_WIDTH-i)>>1,(LCD_HEIGHT-i)>>1,i,i);
		FastCopyScreen(CH_buffer[2],GrayGetPlane(1));
		FastCopyScreen(CH_buffer[2],GrayGetPlane(0));
	}
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline void CH_create_pack_of_trash() {
	int x,y,xc,yc,i;
	xc = random(CH_trash_array_width-2*dispersion)+dispersion;
	yc = random(CH_trash_array_height-2*dispersion)+dispersion;
	for (i=0;i<num_of_trash_per_pack;i++) {
		do {
			x = xc+random(dispersion);
			y = yc+random(dispersion);
		} while (CH_array_of_trash[x][y].exist == 1 || CH_array_of_trash[x][y].in_movement == 1);
		CH_array_of_trash[x][y].exist = 1;
		CH_array_of_trash[x][y].in_movement = 0;
		CH_XOR_a_trash(x,y);
	}
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline void CH_create_one_trash(void) {	//do not "static inline"
	int x,y;
	do {
		x = random(CH_trash_array_width);
		y = random(CH_trash_array_height);
	} while (CH_array_of_trash[x][y].exist == 1 || CH_array_of_trash[x][y].in_movement == 1);
	CH_array_of_trash[x][y].exist = 1;
	CH_array_of_trash[x][y].in_movement = 0;
	CH_XOR_a_trash(x,y);
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

void CH_update_score() {	//do not "static inline"
	char string[30];
	int i;
	for (i=0;i<CH_NOP;i++) {
		sprintf(string,"P%i:  [%i]",i+1,CH_p[i].score);
		PortSet (CH_buffer[0], 239, 127);
		DrawStr(38*i,CH_border_down+5,string,A_REPLACE);
		if (CH_p[i].score>=CH_point_limit)
			CH_winner = i;
	}
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline  void CH_XOR_a_trash(long x,long y) {
	GraySprite8_XOR_R((x<<2)+1,(y<<2)+1,4,CH_trash,CH_trash+4,CH_buffer[0],CH_buffer[1]);
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline void CH_XOR_an_animated_trash(int x,int y) {
	GraySprite8_OR_R(x+1,y+1,4,CH_trash,CH_trash+4,CH_buffer[2],CH_buffer[3]);
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun


void CH_check_angle(int n) {
	if (CH_p[n].angle < 0)
	CH_p[n].angle += 40;
	if (CH_p[n].angle > 40)
	CH_p[n].angle -=40;
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline void CH_change_to_old_coord(int n) {
	CH_p[n].x = CH_p[n].oldx;
	CH_p[n].y = CH_p[n].oldy;	
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline void CH_check_if_collision(int n) {
	if (CH_p[n].y < 2<<7 || CH_p[n].y > CH_s_height<<7) {
		CH_change_to_old_coord(n);
		CH_p[n].angle = -CH_p[n].angle;
		}
	if (CH_p[n].x < 2<<7 || CH_p[n].x > CH_s_width<<7) {	
		CH_change_to_old_coord(n);
		CH_p[n].angle = -CH_p[n].angle+20;
		}
	CH_check_angle(n);
		int i;
		for (i=0;i<CH_NOP;i++) {
			if (TestCollide16(CH_p[i].x>>7,CH_p[i].y>>7,CH_p[n].x>>7,CH_p[n].y>>7,16,CH_dude,CH_dude) && n!=i) {
			CH_p[n].angle = 20+CH_p[n].angle;
			CH_change_to_old_coord(n);
			i=CH_NOP;
			}
		}
	CH_check_angle(n);
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline void CH_animate_da_trash (void) {
	int i;
	for (i=0;i<CH_max_animated_trash;i++) {
		if (CH_moving_trash[i][0]!=255) {
			int x=CH_moving_trash[i][0];
			int y=CH_moving_trash[i][1];
			CH_array_of_trash[x][y].time ++;
			CH_XOR_an_animated_trash(
			(x<<2)+(((CH_array_of_trash[x][y].dx*CH_array_of_trash[x][y].time))>>(8)),
			(y<<2)+(((CH_array_of_trash[x][y].dy*CH_array_of_trash[x][y].time))>>(8))
			);
			if (CH_array_of_trash[x][y].time == 8) {
				CH_array_of_trash[x][y].exist = 0;
				CH_array_of_trash[x][y].in_movement = 0;
				CH_moving_trash[i][0] = 255;
			}
		}
	}	
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline void CH_create_moving_trash(int x,int y) {
	int i=0;
	while (CH_moving_trash[i][0]!=255)	{i++;}//I assume there is enought space in the array (and there sould be!)
	CH_moving_trash[i][0]=x;
	CH_moving_trash[i][1]=y;
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline void CH_check_if_trash_is_near(int n) {
	int x=(CH_p[n].x>>7)+CH_half_player_radius;	//x is the pixel related coord of the center of the player.
	int y=(CH_p[n].y>>7)+CH_half_player_radius;	//y is the pixel related coord of the center of the player.
	int x2 = x>>2;															//x2 is the array related coord of the player.
	int y2 = y>>2;															//y2 is the array related coord of the player.
	int xi,yi;
	int sumx,sumy;
	for (xi = -3;xi<=3;xi++) {
		sumx=xi+x2;
		if (sumx>=0 && sumx<CH_trash_array_width) {
			for (yi = -3;yi<=3;yi++) {
				sumy=yi+y2;
				if (sumy >=0 && sumy<CH_trash_array_height) {
					if (CH_array_of_trash[sumx][sumy].exist == 1) {
						CH_array_of_trash[sumx][sumy].in_movement = 1;
						CH_array_of_trash[sumx][sumy].dx = ((x)-(sumx<<2))<<5;
						CH_array_of_trash[sumx][sumy].dy = ((y)-(sumy<<2))<<5;
						CH_array_of_trash[sumx][sumy].time = 0;					
						CH_array_of_trash[sumx][sumy].exist= 0;					
						CH_create_moving_trash(sumx,sumy);
						CH_p[n].score ++;
						CH_update_score();
						CH_XOR_a_trash(sumx,sumy);
					}
				}
			}
		}
	}
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline void CH_move_player(int n) {
if (_keytest(RR_ESC))
	CH_quit = 1;
	CH_p[n].move = 0;

if ((_keytest(RR_F1) &&  n==0) || ((_keytest(RR_F5) || _keytest(RR_RIGHT)) &&  n==1) || (_keytest(RR_ENTER) &&  n==2) || ((_keytest(RR_STORE) || _keytest(RR_DIAMOND)) &&  n==3))
		CH_p[n].move = 1;																					

	if (!CH_p[n].move) {
	CH_p[n].angle=CH_p[n].angle;
		CH_p[n].angle++;
		if (CH_p[n].angle > 40)
			CH_p[n].angle=0;
	}
	else
	{
	CH_p[n].oldx = CH_p[n].x;
	CH_p[n].oldy = CH_p[n].y;
	CH_p[n].x += CH_Xcos[CH_p[n].angle];
	CH_p[n].y += CH_Xcos[CH_convert_to_sin(CH_p[n].angle)];
	CH_check_if_collision(n);
	}
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline void CH_draw_player(int n) {
		int x,y,a,x2,x3,y2,y3;
		a=CH_p[n].angle;
		x = (CH_p[n].x>>7) + CH_Bcos[a];
		y = (CH_p[n].y>>7) + CH_Bcos[CH_convert_to_sin(a)];
		
		a=CH_p[n].angle+6;
		if (a>40)
		a-=40;
		x2 = (CH_p[n].x>>7) + CH_Bcos[a];
		y2 = (CH_p[n].y>>7) + CH_Bcos[CH_convert_to_sin(a)];
		
		a=CH_p[n].angle-6;
		if (a<0)
		a+=40;
		x3 = (CH_p[n].x>>7) + CH_Bcos[a];
		y3 = (CH_p[n].y>>7) + CH_Bcos[CH_convert_to_sin(a)];
		
	if (x < CH_border_right && x > CH_border_left && y < CH_border_down && y > CH_border_up) {	
		if (x2 < CH_border_right && x2 > CH_border_left && y2 < CH_border_down && y2 > CH_border_up)
		GrayFastDrawLine2B(x,y,x2,y2,COLOR_BLACK,CH_buffer[2],CH_buffer[3]);
		if (x3 < CH_border_right && x3 > CH_border_left && y3 < CH_border_down && y3 > CH_border_up)
		GrayFastDrawLine2B(x,y,x3,y3,COLOR_BLACK,CH_buffer[2],CH_buffer[3]);
	}
	GraySprite16_OR(CH_p[n].x>>7,CH_p[n].y>>7,15,CH_dude,CH_dude,CH_buffer[2],CH_buffer[3]);
	GrayDrawChar2B((CH_p[n].x>>7)+5, (CH_p[n].y>>7)+5,n+49, A_XOR,CH_buffer[2],CH_buffer[3]);
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline void CH_draw_scene() {
    FastCopyScreen(CH_buffer[0],CH_buffer[2]);//DARK
    FastCopyScreen(CH_buffer[1],CH_buffer[3]);//LIGHT
		int i;
		for (i=0;i<CH_NOP;i++)
		CH_draw_player(i);
		CH_animate_da_trash();
    FastCopyScreen(CH_buffer[2],GrayGetPlane (DARK_PLANE));
    FastCopyScreen(CH_buffer[3],GrayGetPlane (LIGHT_PLANE));
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

static inline void CH_play() {
	while (CH_draw_menu()) {
		new_game(g_CH);
		CH_time = 0;
		CH_winner = nobody_wins;	
		int i;
		CH_quit = 0;
		//Init the different players data.
		for (i=0;i<CH_NOP;i++) {
			CH_p[i].x = (i*30+20)<<7;
			CH_p[i].y = 50<<7;
			CH_p[i].angle = 0;
			CH_p[i].score = 0;
		}
		for (i=0;i<CH_max_animated_trash;i++) {
			CH_moving_trash[i][0] = 255;
		}
		CH_update_score();
		GrayDrawRect2B(CH_border_left,CH_border_up,CH_border_right,CH_border_down,COLOR_BLACK,RECT_EMPTY,CH_buffer[0],CH_buffer[1]);
		while (!CH_quit && CH_winner == nobody_wins) {
			CH_time++;
			if (CH_time == 100) {
				CH_create_pack_of_trash();
				CH_time = 0;
			}
			pause(0);
			FontSetSys(F_4x6);
			for (i=0;i<CH_NOP;i++) {
				CH_move_player(i);
				CH_check_if_trash_is_near(i);
			}
			CH_draw_scene();
		}
		if (CH_winner != nobody_wins)
		CH_draw_winner();
	}
}

//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun
//Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun+Sfun-Sfun

// Main Function
void CH_main(void) //MEM NEEDED:(LCD_SIZE*5 + CH_trash_array_height*CH_trash_array_width*sizeof(CH_PIECE_OF_TRASH_STRUCT) + sizeof(char)*2*CH_max_animated_trash + sizeof(int)*2*41)=23188 bytes
{
	int i;
	#define allocated_space (LCD_SIZE*5 + CH_trash_array_height*CH_trash_array_width*sizeof(CH_PIECE_OF_TRASH_STRUCT) + sizeof(char)*2*CH_max_animated_trash + sizeof(int)*2*41)
	memset(UNIVERSAL_POINTER,0,allocated_space);
	//"Distribute" the allocated mem
	for (i=0;i<5;i++) {
		CH_buffer[i] 		= UNIVERSAL_POINTER + LCD_SIZE*i;
	}
	CH_array_of_trash 	= UNIVERSAL_POINTER + LCD_SIZE*5;
	CH_moving_trash 		= UNIVERSAL_POINTER + LCD_SIZE*5 + CH_trash_array_height*CH_trash_array_width*sizeof(CH_PIECE_OF_TRASH_STRUCT);
	CH_Xcos 						= UNIVERSAL_POINTER + LCD_SIZE*5 + CH_trash_array_height*CH_trash_array_width*sizeof(CH_PIECE_OF_TRASH_STRUCT) + sizeof(char)*2*CH_max_animated_trash;
	CH_Bcos 						= UNIVERSAL_POINTER + LCD_SIZE*5 + CH_trash_array_height*CH_trash_array_width*sizeof(CH_PIECE_OF_TRASH_STRUCT) + sizeof(char)*2*CH_max_animated_trash + sizeof(int)*41;
	for (i=0; i <=40; i++) {
		CH_Xcos[i] = fmul(cos(i*PI/20),pow(2,7));
		CH_Bcos[i] = ((CH_Xcos[i]*CH_radius)>>7)+(CH_half_player_radius);
	}
  CH_play();
}

