// Header File
// Created 11/11/2004; 2:10:46 AM

#define LEVEL_WIDTH										300
#define LEVEL_HEIGHT									18
#define LEVEL_MEM											(LEVEL_WIDTH*LEVEL_HEIGHT)
#define CAM_SHIFT											3
#define Y_SHIFT												4
#define VerticalAcceleration 					4

#define HeadMovementPeriod						10
#define SkateMovementPeriod						6
#define BodyMovementPeriod						10
#define G_FAIM 1

enum JumpType {NotJumping,JumpWithSkate,JumpWithoutSkate};
enum TileType {
UpperGround,
LowerGround,
BlackBlock,
GrayBlock,
UpperTree1,
UpperTree2,
LowerTree,
Moutain1,
Mountain2,
EmptyTile,
TreeAndMountain1,
TreeAndMountain2,
TreeAndMountain3,
TreeAndMountain4,
TreeAndMountain5,
TreeAndMountain6,
LowerSky,
Cloud1,
Cloud2,
Cloud3,
Cloud4,
Cloud5,
Cloud6,
Cloud7,
Cloud8
};
