// Header File
// Created 7/12/2004; 7:15:33 PM

//#######################################################
//For the menu
typedef struct {
	int x;
	int y;
	int size;
}MENU_STRUCT;
//#######################################################
//#######################################################
//For Chicorie
typedef struct
    {
    long x;			//shifted 7 bit
    long y;			//shifted 7 bit
    long oldx; 	//shifted 7 bit	//temporarly used	
    long oldy; 	//shifted 7 bit	//temporarly used 
    signed int angle;
    char move;
    int score;
    }CH_PLAYER_STRUCT;
    
typedef struct
	{
		char exist;
		//Those 4 variables are only used when the piece of trash is attracted by a player!
		int dx;			//shifted 4 bit
		int dy;			//shifted 4 bit
		int time;		
		char in_movement;
	}CH_PIECE_OF_TRASH_STRUCT;
//#######################################################
//#######################################################
//For Paper Plane
typedef struct {
	float x;
	int y;
	int a;//angle;
}PA_PL;

typedef struct {
int x;					//shifted 7 bit
int y;					//shifted 7 bit
char vx;				//shifted 4 bit
int vy;				//shifted 4 bit
}PA_PARTICUL;
//#######################################################
//#######################################################
//For Jump forever
typedef struct {
	int x;	//shifted 7 bit
	int y;	//shifted 7 bit
	int vy;	//shifted 7 bit
	char dir;
	char jump_delay;
	char ministep;
	char step;
	int score;
	char moving_horizontaly;
}JU_PLAYER;

//#######################################################
//#######################################################

typedef struct {
	short y;
	short vy;
}VERTICAL_COORD;


typedef struct {
	VERTICAL_COORD SkateY;
	VERTICAL_COORD Y;
	short x;
	short JumpingType;
	short IsCrounching;
	
	short BodyFrame;
	short SkateFrame;
	short HeadFrame;

}JF_STRUCT;

//#######################################################
//#######################################################

typedef struct {
	int score[4];
	int magic;
	int number_of_execution; //(increases each time you execute the program)
	int num_of_games_played[4]; //(increases everytime you play a new game)
}SAVE_STRUCT;

