// C Source File
// Created 7/4/2004; 11:27:14 PM

#include "all.h"

void ME_draw_menu(int);
void ME_exitnow(short);
void _main(void);//MEnu
void JU_main(void);//JUmp forever
void PA_main(void);//PAper plane
void CH_main(void);//CHicorie
void IN_main(void);//INfo
void SK_main(void);//SKate


//<-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><->
//<-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><-><->

//afsehsiofdhashdfohjadsfjpoasjfoajdsfojfasodjdf
//afsehsiofdhashdfohjadsfjpoasjfoajdsfojfasodjdf

void *virtual1=NULL,*virtual0=NULL,*textbuffer=NULL;
MENU_STRUCT *ME_m=NULL;
void *saved_screen;

//afsehsiofdhashdfohjadsfjpoasjfoajdsfojfasodjdf
//afsehsiofdhashdfohjadsfjpoasjfoajdsfojfasodjdf

void ME_draw_menu(int frame) {
	//Because the 2 buffer are next to each other, one big memset is enough
	memset(virtual1,0,ME_SMALL_LCD_SIZE*2);//Clear the 2 buffer
	int j;
	for (j=0;j<ME_nn;j++) {
		ScaleSprite32_OR((unsigned long *)ME_sp+(j<<6),virtual1,ME_m[frame].x,ME_m[frame].y,ME_m[frame].size,ME_m[frame].size);
		ScaleSprite32_OR((unsigned long *)ME_sp+32+((j)<<6),virtual0,ME_m[frame].x,ME_m[frame].y,ME_m[frame].size,ME_m[frame].size);
		frame+=ME_inc;
		if (frame>=ME_n)
			frame-=ME_n;
	}

	memcpy (GrayGetPlane(1)+30*35, virtual1, ME_SMALL_LCD_SIZE);
	memcpy (GrayGetPlane(0)+30*35, virtual0, ME_SMALL_LCD_SIZE);
}

//afsehsiofdhashdfohjadsfjpoasjfoajdsfojfasodjdf
//afsehsiofdhashdfohjadsfjpoasjfoajdsfojfasodjdf

void ME_exitnow(short b) {
	if (b != 2) {
		GrayOff();
		LCD_restore(saved_screen);
		free(saved_screen);
	}
	if (b!=0) {
		ST_helpMsg("Memory Error");
	}
	exit(0);
}

//afsehsiofdhashdfohjadsfjpoasjfoajdsfojfasodjdf
//afsehsiofdhashdfohjadsfjpoasjfoajdsfojfasodjdf

void _main(void)
{
	#define magic_num (11986-111)//11986 - (version num) //version num = 1.11
	read_data(&save);
	if (save.magic != magic_num) {
		memset(save.score,0,4*sizeof(int));
		save.magic = magic_num;
		save.number_of_execution=0;
		memset(save.num_of_games_played,0,4*sizeof(int));
	}
	else
	{
		save.number_of_execution++;
	}
	write_data(&save);
	/*
	Here I allocate the maximun amount of memory I will need (which is the amount of memory required by Chicorie + "LCD_SIZE" to store the saved screen + "30*8*2" for the pause screen).
	After that, I use the same memory over and over again.
	*/
	saved_screen=malloc(LCD_SIZE+((((((LCD_SIZE*5 + CH_trash_array_height*CH_trash_array_width*sizeof(CH_PIECE_OF_TRASH_STRUCT) + sizeof(char)*2*CH_max_animated_trash + sizeof(int)*2*41) + 30*8*2))))));
	//If alloc failed: exit with a mem error.
	if (!saved_screen)
	ME_exitnow(2);
	pause_buffer = saved_screen+LCD_SIZE;
	
	//"Distribute" the mem.
	UNIVERSAL_POINTER=saved_screen+LCD_SIZE+30*8*2;//"UNIVERSAL_POINTER" doesn't change for the rest of the program.
	virtual1 = UNIVERSAL_POINTER;
	virtual0 = (virtual1+ME_SMALL_LCD_SIZE);
	
	//Saves the screen.
	LCD_save(saved_screen);
		
	ST_helpMsg("Patience...");
	int i;
	MENU_STRUCT menu[ME_n];
	ME_m=menu;
	float SIN;
	float angle;
	//Pre-calculate the variables used to give a 3d look to the menu.
	for (i=0;i<ME_n;i++) {
		angle = (((2*PI)/ME_n)*i)+fmul(0.5,sin((((2*PI)/ME_n)*i))+PI);
		ME_m[i].x = 		fmul(cos(angle),40)+70;
		SIN = sin(angle);
		ME_m[i].y = 		fmul(SIN,10)+10;
		ME_m[i].size =	fmul(SIN,12)+20;
	}
	
	INT_HANDLER save_int_1;
	save_int_1 = GetIntVec (AUTO_INT_1);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);

	INT_HANDLER save_int_5;
	save_int_5 = GetIntVec (AUTO_INT_5);
	SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
	if (!GrayOn())	//Test if we can use grayscale, otherwise exit with a mem error. (this is the only GrayOn() in this prgm)
	ME_exitnow(1);
	FontSetSys(F_4x6);
	//Start of the menu:
	char ME_quit=0;
	char str[40];
	do {	


		draw_pic(ME_layer1,ME_layer2,GrayGetPlane(1)+(30*12+4),GrayGetPlane(0)+(30*12+4),13,15,no_score);	

		int frame=4*ME_nn+5;
		char dir;
		FontSetSys(F_4x6);
		ME_draw_menu(frame);			
		while (!_keytest(RR_ENTER)) {
			dir = 0;
			if (_keytest(RR_LEFT))
			dir = 1;
			if (_keytest(RR_RIGHT))
			dir = -1;
			if (_keytest(RR_F1) && _keytest(RR_F5)) {
				read_data(&save);

				sprintf(str,"...:::FDW:::...CH:%i JU:%i PA:%i SK:%i || %i",save.num_of_games_played[0],save.num_of_games_played[1],save.num_of_games_played[2],save.num_of_games_played[3],save.number_of_execution);
				GrayDrawStr(0,0,str,A_NORMAL);
			}
			
			if (dir != 0) {
				for (i=0;i<=ME_nn;i++) {
					frame+=dir;
					if (frame==ME_n)
					frame=0;
					if (frame==-1)
					frame=ME_n-1;
					ME_draw_menu(frame);

				//	printf("%i",frame);printf("%i",frame);printf("%i",frame);printf("%i",frame);printf("%i",frame);printf("%i",frame);
					
				}
			}
		}
	if (frame == 29)
		PA_main();					//Paper Plane
	if (frame == 22)
		IN_main();					//Info
	if (frame == 15)
		JU_main();					//Jump forever
	if (frame == 8)
		SK_main();					//Skate	
	if (frame == 1)
		CH_main();					//Chicorie
	if (frame == 36)
		ME_quit = 1;				//Quit
		

	} while (!ME_quit);
		
		while (_keytest(RR_ENTER)) {	};	
		GrayOff();	//The only GrayOff() in this prgm
		SetIntVec (AUTO_INT_1, save_int_1);
		SetIntVec (AUTO_INT_5 , save_int_5);
		LCD_restore(saved_screen);
		ST_helpMsg("Visit http://oragestudio.free.fr !");    
		free(saved_screen);

}