// C Source File
// Created 5/9/2004; 10:34:33 AM

#include "all.h"


static inline void PA_draw_plane(void);
static inline void PA_draw_obstacle(void);
static inline void PA_draw_new_obstacle(void);
void PA_draw_one_obstacle(int,int,char,int);
void PA_cpy_buffer_to_screen(void);
static inline void PA_draw_explosio(void);
void _main(void);
static inline void PA_get_input(int*);
static inline void PA_move_plane(void);
static inline char PA_menu(void);
static inline void PA_play(void);
static inline void PA_scroll(void);



//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.



PA_PL p;
float PA_vx[9] = {-1.4,-.9,-.6,-.16,0,.16,.6,.9,1.4};
int PA_vy[9] = {15,30,50,75,100,75,50,30,15};
char PA_str[2][8] = {"Normal ","Reverse"};
int PA_scroll_delay;
int PA_obstacle_delay;
int PA_transition_delay;
int PA_width;
int PA_provisional_thickness;
int PA_thickness;
int PA_transition;
int PA_kbd_settings;
int PA_loss;
void *PA_buffer[4];
int PA_score;

//Debug
//int PA_XX;
char it[16];




//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.


static inline void PA_scroll () {
	PA_scroll_delay+=PA_vy[p.a];
	while (PA_scroll_delay > 100) {
		ScrollUp160(PA_buffer[0],PA_max_buffer_height-1);
		ScrollUp160(PA_buffer[1],PA_max_buffer_height-1);
		PA_scroll_delay-=100;
		EXT_SETPIX(PA_buffer[0],random(160),99);
		PA_obstacle_delay++;
	}
}


//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.


void PA_cpy_buffer_to_screen() {
	memcpy(GrayGetPlane(0),PA_buffer[0],100*30);
	memcpy(GrayGetPlane(1),PA_buffer[1],100*30);
	
	
}
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.

static inline void PA_draw_plane() {
	/*
	int offset=p.y*30;
	
	memcpy(PA_buffer[2],PA_buffer[0]+offset,16*30);
	memcpy(PA_buffer[3],PA_buffer[1]+offset,16*30);

	GraySprite16_MASK(p.x,p.y,16,PA_plane_sprite[p.a],&PA_plane_sprite[p.a][16],PA_plane_sprite_mask[p.a],PA_plane_sprite_mask[p.a],PA_buffer[1],PA_buffer[0]);

	PA_cpy_buffer_to_screen();
	Sprite16_OR(p.x+PA_s_offset_x,p.y+PA_s_offset_y,16,&PA_plane_sprite[p.a][16],GrayGetPlane(0));
	memcpy(PA_buffer[0]+offset,PA_buffer[2],16*30);
	memcpy(PA_buffer[1]+offset,PA_buffer[3],16*30);
	
	int i;
	char r[5];
	sprintf(r,"%d",PA_score);
	for (i=0;i<3;i++) {
 		if (r[i] >47 && r[i] < 58)
 		GraySprite8_OR_R((i<<3)+5,10,8,number_sprite[r[i]-48],PA_number_sprite[r[i]-48],GrayGetPlane(1),GrayGetPlane(0));
	}
	//int offset=p.y*30;
	*/




	unsigned short XX[32];
	
	//local double buff'
	Sprite16Get_R(p.x,p.y,16,PA_buffer[1],XX);
	Sprite16Get_R(p.x,p.y,16,PA_buffer[0],&XX[16]);

	GraySprite16_MASK_R(p.x,p.y,16,PA_plane_sprite[p.a],&PA_plane_sprite[p.a][16],PA_plane_sprite_mask[p.a],PA_plane_sprite_mask[p.a],PA_buffer[1],PA_buffer[0]);
	
	PA_cpy_buffer_to_screen();

	Sprite16_OR_R(p.x+PA_s_offset_x,p.y+PA_s_offset_y,16,&PA_plane_sprite[p.a][16],GrayGetPlane(0));
	
	GraySprite16_RPLC_R(p.x,p.y,16,XX,&XX[16],PA_buffer[1],PA_buffer[0]);
	
	ALL_draw_score(PA_score,1, 10,GrayGetPlane(0), GrayGetPlane(1));
	
	
	/*
	int i;
	char r[5];
	sprintf(r,"%d",PA_score);
	for (i=0;i<3;i++) {
 		if (r[i] >47 && r[i] < 58)
 		GraySprite8_OR_R((i<<3)+5,10,8,number_sprite[r[i]-48],PA_number_sprite[r[i]-48],GrayGetPlane(1),GrayGetPlane(0));
	}
	*/
}

//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.


void xor_particul(int x,int y) {
if (x >0 && x < 158 && y < 99) {
	EXT_XORPIX(PA_buffer[0],x,y);
	EXT_XORPIX(PA_buffer[1],x,y);
	EXT_XORPIX(PA_buffer[0],x+1,y);
	EXT_XORPIX(PA_buffer[1],x+1,y);
	EXT_XORPIX(PA_buffer[0],x,y-1);
	EXT_XORPIX(PA_buffer[1],x,y-1);
	EXT_XORPIX(PA_buffer[0],x+1,y-1);
	EXT_XORPIX(PA_buffer[1],x+1,y-1);
	}
}

//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.


static inline void PA_draw_explosio() {
	

	PA_PARTICUL pa[PA_nop];
	int i,j;
	for (i=0;i<PA_nop;i++) {
		pa[i].y = (p.y+2+random(10))<<7;
		j=p.x;
		pa[i].x = j<<7;
		pa[i].vx = (random(21)-10)<<4;
		pa[i].vy = (-random(10))<<4;
	}
	
	for (i=0;i<80;i++) {
		for (j=0;j<PA_nop;j++) {
			xor_particul(pa[j].x>>7,pa[j].y>>7);;
			pa[j].x+=pa[j].vx;
			pa[j].y+=pa[j].vy;
			pa[j].vy += 1<<2;
			xor_particul(pa[j].x>>7,pa[j].y>>7);
		}
		
		
		for (j=0;j<3;j++) {
			pokeIO(0x600005,0b11111);
		}
		PA_cpy_buffer_to_screen();
	}
}

//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.

void PA_draw_one_obstacle(int offset_x,int offset_y,char color,int x) {	
	FastDrawGrayHLine2B(0,x+offset_x, 100+offset_y,color,PA_buffer[0],PA_buffer[1]);
	FastDrawGrayHLine2B(0,x+offset_x, 101+offset_y,color,PA_buffer[0],PA_buffer[1]);
	FastDrawGrayHLine2B(0,x+offset_x, 100+offset_y+PA_provisional_thickness,color,PA_buffer[0],PA_buffer[1]);
	FastDrawGrayHLine2B(0,x+offset_x, 101+offset_y+PA_provisional_thickness,color,PA_buffer[0],PA_buffer[1]);
	FastDrawGrayHLine2B(x+offset_x+PA_width,LCD_WIDTH-1, 100+offset_y,color,PA_buffer[0],PA_buffer[1]);
	FastDrawGrayHLine2B(x+offset_x+PA_width,LCD_WIDTH-1, 101+offset_y,color,PA_buffer[0],PA_buffer[1]);
	FastDrawGrayHLine2B(x+offset_x+PA_width,LCD_WIDTH-1, 100+offset_y+PA_provisional_thickness,color,PA_buffer[0],PA_buffer[1]);
	FastDrawGrayHLine2B(x+offset_x+PA_width,LCD_WIDTH-1, 101+offset_y+PA_provisional_thickness,color,PA_buffer[0],PA_buffer[1]);
	FastDrawGrayLine2B(x+offset_x+1,101+offset_y,x+offset_x+1,100+offset_y+PA_provisional_thickness,color,PA_buffer[0],PA_buffer[1]);
	FastDrawGrayLine2B(x+offset_x+PA_width-1,101+offset_y,x+offset_x+PA_width-1,100+offset_y+PA_provisional_thickness,color,PA_buffer[0],PA_buffer[1]);
}

//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.

static inline void PA_draw_new_obstacle() {
	int x=0;
	PA_transition_delay++;
	if (PA_transition == 0 && PA_transition_delay==PA_start_of_transition) {
		PA_transition = 1;
		PA_transition_delay = 0;
	}
	if (PA_transition == 1 && PA_transition_delay==PA_transition_length) {
		PA_transition = 0;
		PA_transition_delay = 0;
		PA_thickness += 15;
		if (PA_thickness > 55) {
			PA_width -= 6;
			PA_thickness = 5;
		}
	}
	if (PA_transition==0) {
		//If PA_score is odd (<=> (PA_score&1) ), the path will be on the right, otherwise it will be on the left.
		x=random(20)+20+(PA_score&1)*80;
		PA_provisional_thickness = PA_thickness;
	}
	else
	{
		PA_provisional_thickness = 65;
		x=(160-PA_width)>>1;
	}
	if (!(PA_transition == 1 && PA_transition_delay==PA_transition_length-1)) {
		PA_draw_one_obstacle(PA_s_offset_x,PA_s_offset_y,COLOR_LIGHTGRAY,x);
		PA_draw_one_obstacle(0,0,COLOR_BLACK,x);
	}
}

//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.

static inline void PA_detect_loss() {
	PortSet(PA_buffer[1],239,127);
	if (GetPix(p.x+7,p.y+7)!=0 || p.x <2 || p.x > 157) {
		PA_loss=1;
		PA_draw_explosio();
	}
}

//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.

static inline void PA_draw_obstacle() {
	if (PA_obstacle_delay >= PA_end_of_obstacle_delay) {
		PA_draw_new_obstacle();
		PA_obstacle_delay = 0;
		PA_score++;
	}
}

//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.

static inline void PA_get_input(int *delay) {
	if (*delay>=PA_end_of_scroll_delay) {
		if (p.a != 8 && ((_keytest(RR_RIGHT) && PA_kbd_settings==0) || (_keytest(RR_LEFT) && PA_kbd_settings==1))) {
			p.a++;
			*delay=0;
		}
		if (p.a != 0 && ((_keytest(RR_RIGHT) && PA_kbd_settings==1) || (_keytest(RR_LEFT) && PA_kbd_settings==0))) {
			p.a--;
			*delay=0;
		}
	}
}

//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.

static inline char PA_menu() {
		
		draw_pic(PA_layer1,PA_layer2,GrayGetPlane(1)+2+30*12,GrayGetPlane(0)+2+30*12,17,34,paper_plane);
		FontSetSys(F_4x6);
		GrayDrawStr(40,65,"[1] Start",A_NORMAL);
		GrayDrawStr(40,75,"[2] Exit",A_NORMAL);
		GrayDrawStr(40,85,"[3] Change keys:",A_NORMAL);
		PA_kbd_settings = 0;
		GrayDrawStr(100,85,PA_str[PA_kbd_settings],A_NORMAL);
    while (1) {
    	if (_keytest(RR_1)) {
    			return 1;
    		}
    	if (_keytest(RR_2)) {
    			while (_keytest(RR_2)) {};
    			return 0;
    		}
    	if (_keytest(RR_3)) {
    			PA_kbd_settings = !PA_kbd_settings;
    			GrayDrawStr(100,85,PA_str[PA_kbd_settings],A_REPLACE);
    			while (_keytest(RR_3)) {};
    	}
    }
}
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.

static inline void PA_move_plane() {
	p.x += PA_vx[p.a];
}

//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.


static inline void PA_play() {
	new_game(g_PA);
	PA_score = 0;
	
	memset(PA_buffer[0],0,PA_max_buffer_height*30*2);//Clears the buffers.
	PA_loss=0;
	p.a = 4;
	p.x = 55;
	p.y = 30;
	PA_obstacle_delay = 0;
	PA_scroll_delay=0;
	//Debug
	//PA_XX = 1;
	PA_thickness =5;
	PA_transition = 0;
	PA_transition_delay = 0;
	
	int delay=0;
	PA_width = 35;
	
	while (!_keytest(RR_ESC) && !PA_loss) {
		PA_get_input(&delay);
		pause(0);
		delay++;
		PA_move_plane();
		PA_draw_obstacle();
		PA_scroll();
		PA_draw_plane();
		PA_detect_loss();
	}
	if (save.score[paper_plane] <PA_score) {
		save.score[paper_plane] = PA_score;
		write_data(&save);
	}
	

}


//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.
//.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.-=#=-.


void PA_main(void)
{
	
	PA_buffer[0]=UNIVERSAL_POINTER;
	PA_buffer[1] = UNIVERSAL_POINTER + (PA_max_buffer_height*30);
	PA_buffer[2] = PA_buffer[1]+ (PA_max_buffer_height*30) + 23*30;
	PA_buffer[3] = PA_buffer[2]+23*30;
	
	while (PA_menu())
	PA_play();


}
